# Bitalino data acquisition and analysis

- Stream data from a [Bitalino](https://www.pluxbiosignals.com) sensor
  to a CSV file or LSL.
- Pre-processing example with [Neurokit2](https://github.com/neuropsychology/NeuroKit).

## Bluetooth

Pair the bitalino: pin 1234.

On Linux `bluetoothctl` is useful for seeing exactly what is going on
with bluetooth devices.

```sh
$ bluetoothctl --help
$ bluetoothctl devices
$ bluetoothctl info xx:xx:xx:xx:xx:xx
$ bluetoothctl pair xx:xx:xx:xx:xx:xx
$ bluetoothctl trust xx:xx:xx:xx:xx:xx
$ bluetoothctl connect xx:xx:xx:xx:xx:xx
$ bluetoothctl disconnect xx:xx:xx:xx:xx:xx
```

Disconnect before running the Python scripts as the `PLUX` library
will establish a new connection.

## Install

Virtual environment can be created and managed with
[`uv`](https://docs.astral.sh/uv/) or manually with `venv` and `pip`
etc.


```sh
$ git clone https://gitlab.doc.gold.ac.uk/cc-project-demos/demo-eda-analysis.git
$ cd demo-eda-analysis
$ git submodule update --init
$ uv sync
```

## Running

```sh
$ source .venv/bin/activate
$ bitalino-csv --help
$ bitalino-lsl --help
```

## PLUX API

Uses [`PLUX Python
API`](https://www.downloads.plux.info/apis/PLUX-API-Python-Docs/) to
access sensor data.

Biosignals only ship pre-compiled binaries of their SDK, and they are
not packaged as installable Python components. This means the shared
libraries *for your particular OS* must be available on your Python
path. All current versions of the SDK are downloaded to `./src/plux/`
using the above `git submodule` command. This demo tries to identify
the correct one for you but this has only been tested on Linux!
