import platform
import sys
import importlib.util


osDic = {
    "Darwin": f"MacOS/Intel{''.join(platform.python_version().split('.')[:2])}",
    "Linux": "Linux64",
    "Windows": f"Win{platform.architecture()[0][:2]}_{''.join(platform.python_version().split('.')[:2])}",
}
if platform.mac_ver()[0] != "":
    import subprocess
    from os import linesep

    p = subprocess.Popen("sw_vers", stdout=subprocess.PIPE)
    result = p.communicate()[0].decode("utf-8").split(str("\t"))[2].split(linesep)[0]
    if result.startswith("12."):
        print("macOS version is Monterrey!")
        osDic["Darwin"] = "MacOS/Intel310"
        if (
            int(platform.python_version().split(".")[0]) <= 3
            and int(platform.python_version().split(".")[1]) < 10
        ):
            print(
                f"Python version required is ≥ 3.10. Installed is {platform.python_version()}"
            )
            sys.exit(1)

spec = importlib.util.find_spec("plux")
if spec.loader is None:
    base_path = spec.submodule_search_locations
    if base_path is not None and len(base_path) == 1:
        plux_path = f"{base_path[0]}/PLUX-API-Python3/{osDic[platform.system()]}"
        print(f"Found plux lib: {plux_path}")
        sys.path.append(plux_path)
    else:
        print("Could not find plux lib, should be in bitalino/src/plux/.")
